if select(2, UnitClass("player")) ~= "WARLOCK" then return end
local GetSpellInfo = DrDamage.SafeGetSpellInfo
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local UnitExists = UnitExists
local UnitIsFriend = UnitIsFriend
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitIsUnit = UnitIsUnit
local math_min = math.min
local math_max = math.max
local math_ceil = math.ceil
local select = select
local GetPetSpellBonusDamage = GetPetSpellBonusDamage
local GetSpellCritChanceFromIntellect = GetSpellCritChanceFromIntellect
local Orc = (select(2,UnitRace("player")) == "Orc")
local IsSpellKnown = IsSpellKnown

local spells = { [GetSpellInfo(7814) or "Lash of Pain"] = true, [GetSpellInfo(54049) or "Shadow Bite"] = true, [GetSpellInfo(3110) or "Firebolt"] = true, }
function DrDamage:UpdatePetSpells()
	self:UpdateAB(spells)
end

function DrDamage:PlayerData()
	--Health updates
	self.PlayerHealth = { [1] = 0.251, [0.251] = GetSpellInfo(689) }
	self.TargetHealth = { [1] = 0.251, }
--GENERAL
	self.Calculation["Stats"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		local mastery = calculation.mastery
		local masteryLast = calculation.masteryLast
		local spec = calculation.spec
		if spec == 1 then
			if mastery > 0 and mastery ~= masteryLast then
				if (calculation.school == "Shadow" --[[or calculation.school == "Shadowflame"--]]) and (baseSpell.eDot or baseSpell.Drain) --[[and calculation.group ~= "Pet"--]] then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						if baseSpell.Drain then
							calculation.dmgM_Add = calculation.dmgM_Add - masteryBonus
						else
							calculation.dmgM_dot_Add = calculation.dmgM_dot_Add - masteryBonus
						end
					end
					local bonus = mastery * 0.01 * 1.63
					if baseSpell.Drain then
						calculation.dmgM_Add = calculation.dmgM_Add + bonus
					else
						--Mastery is additive with Improved Corruption - 4.0.3
						calculation.dmgM_dot_Add = calculation.dmgM_dot_Add + bonus
					end
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				end
			end
		elseif spec == 2 then
			if mastery > 0 and mastery ~= masteryLast then
				if calculation.group == "Pet" or (ActiveAuras["Metamorphosis"] == 0) then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM / masteryBonus
					end
					--NOTE: For Pet tooltips only base damage is affected
					--Mastery: Master Demonologist
					local bonus = 1 + mastery * 0.01 * 2.3
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				end
			end
		elseif spec == 3 then
			if mastery > 0 and mastery ~= masteryLast then
				if (calculation.school == "Fire" or calculation.school == "Shadowflame") and calculation.group ~= "Pet" then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM / masteryBonus
					end
					--Mastery: Fiery Apocalpyse
					local bonus = 1 + mastery * 0.01 * 1.35
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				end
			end
		end
	end
	self.Calculation["WARLOCK"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		--General stats
		if IsSpellKnown(86091) then
			calculation.intM = calculation.intM * 1.05
		end
		--General bonuses
		if calculation.group == "Pet" then
			if Orc then
				calculation.dmgM = calculation.dmgM * 1.05
			end
		else
			--TODO: Verify
			if ActiveAuras["Metamorphosis"] == 0 then
				calculation.dmgM = calculation.dmgM * 1.2
			end
		end
		if not baseSpell.NoSchoolTalents then
			local spec = calculation.spec
			if spec == 1 then
				-- Checked in 4.1 - Shadow Mastery bonus went from 25% to 30%
				if calculation.school == "Shadow" or calculation.school == "Shadowflame" then
					--NOTE: Pets don't gain, but tooltips show base damage gain
					if calculation.group ~= "Pet" then
						if calculation.spellName == "Haunt" then
							--BUG: Haunt only gains base damage?
							calculation.bDmgM = calculation.bDmgM * 1.3
						else
							calculation.dmgM = calculation.dmgM * 1.3
						end
					end
				end
			elseif spec == 2 then
				if calculation.school == "Shadow" or calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						--Multiplicative 4.0
						calculation.dmgM = calculation.dmgM * 1.15
					end
				end
			elseif spec == 3 then
				if calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						calculation.dmgM = calculation.dmgM * 1.25
					end
				end
			end
		end
	end
--ABILITIES
	local damage_text = GetSpellInfo(48360)
	self.Calculation["Life Tap"] = function( calculation, _, Talents )
		if not self:HasGlyph(63320) then
			local amount = UnitHealthMax("player") * 0.15  
			calculation.minDam = amount
			calculation.maxDam = amount
			calculation.customText = damage_text
			calculation.customTextValue = 0.15 * UnitHealthMax("player")
		end
	end
	local heal = GetSpellInfo(2050)
	self.Calculation["Drain Life"] = function( calculation, ActiveAuras, Talents )
		--calculation.customTextValue = 0.06 * UnitHealthMax("player") * (ActiveAuras["Demon Armor"] or 1)
		calculation.customTextValue = 0.02 * UnitHealthMax("player")
		if ActiveAuras["Soulburn"] then
			calculation.customTextValue = calculation.customTextValue * 1.5
		end
		if ActiveAuras["Demon Armor"] then
			calculation.customTextValue = calculation.customTextValue * 1.1
		end
		if self:HasGlyph(63302) then
			calculation.customTextValue = calculation.customTextValue * 1.3
		end
		calculation.customText = heal
	end
	self.Calculation["Drain Soul"] = function ( calculation, ActiveAuras, Talents, spell )
		if UnitHealth("target") ~= 0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.2 then
			calculation.minDam = calculation.minDam * 2
			calculation.maxDam = calculation.maxDam * 2
		end
	end
	--self.Calculation["Incinerate"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Soul Fire"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Chaos Bolt"] = function( calculation, ActiveAuras, Talents )
	--end
	--self.Calculation["Immolate"] = function( calculation )
	--end
	--self.Calculation["Corruption"] = function( calculation )
	--end
	--self.Calculation["Conflagrate"] = function( calculation, ActiveAuras, Talents )
	--end
	--self.Calculation["Unstable Affliction"] = function( calculation )
	--end
	--self.Calculation["Shadow Bolt"] = function( calculation )
	--end
	--self.Calculation["Immolation Aura"] = function( calculation, ActiveAuras )
	--end
	--self.Calculation["Demon Leap"] = function( calculation, ActiveAuras )
	--end
	--self.Calculation["Firebolt"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Shadow Bite"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Lash of Pain"] = function( calculation, ActiveAuras, Talents, spell )
	--end
--SETS
	self.SetBonuses["T10"] = { 50240, 50241, 50242, 50243, 50244, 51230, 51231, 51232, 51233, 51234, 51205, 51206, 51207, 51208, 51209, }
--AURA
--Player
	--Demonic Soul (T7 proc)
	self.PlayerAura[GetSpellInfo(61595)] = { Spells = { "Shadow Bolt", "Incinerate" }, ModType = "critPerc", Value = 10, NoManual = true }
	--Fel Spark (T11 4p proc)
	self.PlayerAura[GetSpellInfo(89937)] = { Spells = "Fel Flame", Value = 3, NoManual = true }
	--Devious Minds (T10 4p 10% damage)
	self.PlayerAura[GetSpellInfo(70840)] = { School = "Pet", Value = 0.1, NoManual = true }
	--Eradication (Affliction proc)
	self.PlayerAura[GetSpellInfo(47195)] = { Update = true }
	--Decimation (Demonology proc)
	self.PlayerAura[GetSpellInfo(63156)] = { Update = true, Spells = "Soul Fire" }
	--Backlash (Destruction proc)
	self.PlayerAura[GetSpellInfo(34935)] = { Update = true, Spells = { "Incinerate", "Shadow Bolt" } }
	--Empowered Imp (Destruction proc)
	self.PlayerAura[GetSpellInfo(47283)] = { Update = true, Spells = "Soul Fire" }
	--Molten Core (Demonology proc)
	self.PlayerAura[GetSpellInfo(47383)] = { Spells = "Incinerate", ActiveAura = "Molten Core", ID = 47383 }
	--Metamorphosis
	self.PlayerAura[GetSpellInfo(59672)] = { ActiveAura = "Metamorphosis", Index = true, ID = 59672 }
	--Soulburn
	self.PlayerAura[GetSpellInfo(74434)] = { ActiveAura = "Soulburn", Spells = { "Soul Fire", "Drain Life" }, ID = 74434 }
	--Demon Soul: Imp - Critical strike chance of your cast time Destruction spells increased by 30%.
	--TODO: Hellfire? Rain of Fire?
	self.PlayerAura[GetSpellInfo(79459)] = { Spells = { "Soul Fire", "Incinerate", "Shadow Bolt", "Chaos Bolt" }, ModType = "critPerc", Value = 30, ID = 79459 }
	--Demon Soul: Succubus
	self.PlayerAura[GetSpellInfo(79463)] = { Spells = "Shadow Bolt", Value = 0.1, ID = 79463 }
	--Demon Soul: Felhunter
	self.PlayerAura[GetSpellInfo(79460)] = { School = "Shadow", ID = 79460, Not = "Pet", ModType =
		function( calculation )
			if calculation.spellName == "Drain Life" or calculation.spellName == "Drain Soul" then
				calculation.dmgM = calculation.dmgM * 1.2
			else
				calculation.dmgM_dot = calculation.dmgM_dot * 1.2
			end
		end
	}
	--TODO: Demon Soul: Felguard. Does API handle it?
	--Improved Soul Fire (Destruction proc)
	self.PlayerAura[GetSpellInfo(85383)] = { School = { "Fire", "Shadow" }, Ranks = 2, Value = 0.04 }
	--Apocalypse (T12 proc)
	self.PlayerAura[GetSpellInfo(99232)] = { School = { "Fire", "Shadow" }, Value = 0.2, NoManual = true }

--Target
	--Immolate
	self.TargetAura[GetSpellInfo(348)] = { ActiveAura = "Immolate", Ranks = 11, Spells = { "Incinerate", "Conflagrate", "Chaos Bolt" }, SelfCast = true, ID = 348 }
	--Curse of Gul'dan
	self.TargetAura[GetSpellInfo(86000)] = { School = "Pet", ID = 86000, ModType = "spellCrit", Value = 10 }
	--Soul Siphon
		--Corruption
		self.TargetAura[GetSpellInfo(172)] = 	{ ActiveAura = "Soul Siphon", Spells = { "Drain Life", "Drain Soul" }, SelfCast = true, NoManual = true }
		--Bane of Agony
		self.TargetAura[GetSpellInfo(980)] = 	self.TargetAura[GetSpellInfo(172)]
		--Bane of Doom
		self.TargetAura[GetSpellInfo(603)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Weakness
		self.TargetAura[GetSpellInfo(702)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Tongues
		self.TargetAura[GetSpellInfo(1714)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Exhaustion
		self.TargetAura[GetSpellInfo(18223)] = 	self.TargetAura[GetSpellInfo(172)]
		--Unstable Affliction
		self.TargetAura[GetSpellInfo(30108)] = 	self.TargetAura[GetSpellInfo(172)]
		--Seed of Corruption
		self.TargetAura[GetSpellInfo(27243)] = 	self.TargetAura[GetSpellInfo(172)]
		--Fear
		self.TargetAura[GetSpellInfo(5782)] = 	self.TargetAura[GetSpellInfo(172)]
		--Howl of Terror
		self.TargetAura[GetSpellInfo(5484)] = 	self.TargetAura[GetSpellInfo(172)]
--Custom
	--Curse of the Elements (debuff added in Aura.lua)
	self.TargetAura[GetSpellInfo(1490)].ActiveAura = "Soul Siphon"
	--Demon Armor
	self.PlayerAura[GetSpellInfo(79934)] = { Spells = { "Drain Life" }, ID = 687, ModType =
		function( calculation, ActiveAuras, Talents )
			calculation.leechBonus = (calculation.leechBonus or 0) * 1.2 
			ActiveAuras["Demon Armor"] = 1.2 
		end
	}
	--Backdraft
	self.PlayerAura[GetSpellInfo(117828)] = { NoManual = true, ModType =
		function( calculation, _, Talents )
			calculation.haste = calculation.haste * 1.3
		end
	}
	--Haunt
	self.TargetAura[GetSpellInfo(48181)] = { School = "Shadow", SelfCast = true, ID = 48181, Not = { "Pet" }, Value = 0.3, ModType = "dmgM" }

	self.spellInfo = {
		[GetSpellInfo(172)] = {
					["Name"] = "Corruption",
					["ID"] = 172,
					["Data"] = { 0.153, 0, 0.176 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 6, eDot = true, eDuration = 18, sTicks = 3 },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(686)] = {
					["Name"] = "Shadow Bolt",
					["ID"] = 686,
					["Data"] = { 0.62, 0.11, 0.754, ["ct_min"] = 1700, ["ct_max"] = 3000  },
					[0] = { School = { "Shadow", "Destruction" } },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(1454)] = {
					["Name"] = "Life Tap",
					["ID"] = 1454,
					[0] = { School = { "Shadow", "Utility", }, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(6229)] = {
					["Name"] = "Shadow Ward",
					["ID"] = 6229,
					["Data"] = { 3.69, 0 },
					[0] = { School = { "Shadow", "Absorb" }, SPBonus = 0.807, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true, },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(980)] = {
					["Name"] = "Bane of Agony",
					["ID"] = 980,
					["Data"] = { 0.133, 0, 0.088 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 12, eDot = true, eDuration = 24, sTicks = 2, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(603)] = {
					["Name"] = "Bane of Doom",
					["ID"] = 603,
					["Data"] = { 2.024, 0, 0.88  },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 4, eDot = true, eDuration = 60, sTicks = 15 },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(6789)] = {
					["Name"] = "Death Coil",
					["ID"] = 6789,
					["Data"] = { 0.784, 0, 0.188 },
					[0] = { School = { "Shadow", "Affliction", "Leech" }, Cooldown = 120, Leech = 3, NoDoom = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(689)] = {
					["Name"] = "Drain Life",
					["ID"] = 689,
					["Data"] = { 0.0855, 0, 0.129 },
					[0] = { School = { "Shadow", "Affliction" }, Hits = 3, sTicks = 1, Channeled = 3, Drain = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(1120)] = {
					["Name"] = "Drain Soul",
					["ID"] = 1120,
					["Data"] = { 0.08, 0, 0.378  },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 5, sTicks = 3, Channeled = 15, Drain = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(6353)] = {
					["Name"] = "Soul Fire",
					["ID"] = 6353,
					["Data"] = { 2.543, 0.225, 0.726 },
					[0] = { School = { "Fire", "Destruction" }, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(17877)] = {
					["Name"] = "Shadowburn",
					["ID"] = 17877,
					["Data"] = { 0.714, 0.11, 1.056 },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 15, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(348)] = {
					["Name"] = "Immolate",
					["ID"] = 348,
					["Data"] = { 0.371, 0, 0.371, 0.371, 0, 0, ["c_scale"] = 0.55  },
					[0] = { School = { "Fire", "Destruction" }, Hits_dot = 5, eDuration = 15, sTicks = 3, },
					[1] = { 0, 0, hybridDotDmg = 0, },
		},
		[GetSpellInfo(1949)] = {
					["Name"] = "Hellfire",
					["ID"] = 1949,
					["Data"] = { 0.332, 0, 0.095, },
					[0] = { School = { "Fire", "Destruction" }, Hits = 15, Channeled = 15, sTicks = 1, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(5740)] = {
			-- Checked in 4.1
					["Name"] = "Rain of Fire",
					["ID"] = 5740,
					["Data"] = { 0.797, 0, 0.238, },
					[0] = { School = { "Fire", "Destruction" }, Hits = 4, Channeled = 8, sTicks = 2, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(30108)] = {
					["Name"] = "Unstable Affliction",
					["ID"] = 30108,
					["Data"] = { 0.232, 0, 0.2 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 5, eDot = true, eDuration = 15, sTicks = 3, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(17962)] = {
					["Name"] = "Conflagrate",
					["ID"] = 17962,
					[0] = { School = { "Fire", "Destruction" }, Cooldown = 10, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(27243)] = {
			-- Checked in 4.1
					["Name"] = "Seed of Corruption",
					["ID"] = 27243,
					["Data"] = { 0.7656, 0.15, 0.2292, 0.3024, 0, 0.3  },
					["Data2"] = function(baseSpell, spell, playerLevel)
						baseSpell.Cap = 2.113 * self.Scaling[playerLevel]
						baseSpell.Cap_SPBonus = 0.1716
					end,
					[0] = { School = { "Shadow", "Affliction", }, Hits_dot = 6, eDuration = 18, sTicks = 3, NoDotAverage = true, AoE = true },
					[1] = { 0, 0, hybridDotDmg = 0 },
		},
		[GetSpellInfo(30283)] = {
					["Name"] = "Shadowfury",
					["ID"] = 30283,
					["Data"] = { 0.783, 0.175, 0.214, },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 20, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(29722)] = {
					["Name"] = "Incinerate",
					["ID"] = 29722,
					["Data"] = { 0.573, 0.15, 0.539 },
					[0] = { School = { "Fire", "Destruction" }, },
					[1] = { 0, 0, 0, 0 },
		},
		[GetSpellInfo(47897)] = {
					["Name"] = "Shadowflame",
					["ID"] = 47987,
					["Data"] = { 0.727, 0.09, 0.102, },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 12, },
					[1] = { 0, 0, },
			["Secondary"] = {
					["Name"] = "Shadowflame",
					["ID"] = 47897,
					["Data"] = { 0, 0, 0, 0.169, 0, 0.2  },
					[0] = { School = { "Fire", "Destruction" }, Hits_dot = 3, eDuration = 6, sTicks = 2, Cooldown = 12 },
					[1] = { 0, 0, hybridDotDmg = 0 },
			},
		},
		[GetSpellInfo(48181)] = {
					["Name"] = "Haunt",
					["ID"] = 48181,
					["Data"] = { 0.9581, 0, 0.5577 * 1.25 },
					[0] = { School = { "Shadow", "Affliction" }, Cooldown = 8 },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(116858)] = {
					["Name"] = "Chaos Bolt",
					["ID"] = 116858,
					["Data"] = { 1.547, 0.238, 0.628, },
					[0] = { School = { "Fire", "Destruction" }, Unresistable = true, Cooldown = 12, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(50589)] = {
					["Name"] = "Immolation Aura",
					["ID"] = 50589,
					["Data"] = { 0.589, 0, 0.1, },
					[0] = { School = "Fire", Channeled = 15, Hits = 15, sTicks = 1, Cooldown = 30, AoE = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(54785)] = {
					["Name"] = "Demon Leap",
					["ID"] = 54785,
					["Data"] = { 2.514, 0.17, 0.214, },
					[0] = { School = "Shadow", AoE = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(3110)] = {
					["Name"] = "Firebolt",
					["ID"] = 3110,
					["Data"] = { 0.123, 0.11, 0.657, ["ct_min"] = 2000, ["ct_max"] = 2500 },
					[0] = { School = { "Fire", "Pet" }, SPBonus = 0.657, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, NoDPSC = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(54049)] = {
			-- Checked in 4.1
					["Name"] = "Shadow Bite",
					["ID"] = 54049,
					--Tooltip displays wrong base values, range is halved
					-- ["Data"] = { 0.163, 0.35 / 2 }, (4.0.3 values)
					["Data"] = { 0.326, 0.35 / 2 },
					[0] = { School = { "Shadow", "Pet" }, SPBonus = 1.228, Cooldown = 6, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(7814)] = {
			-- Checked in 4.1
					["Name"] = "Lash of Pain",
					["ID"] = 7814,
					--Tooltip displays wrong base values, multiplier of 1.5 seems to give correct values
					["Data"] = { 0.201 * 1.5, 0.16 / 1.5, ["c_scale"] = 1/3 },
					[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.612, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(86121)] = {
					["Name"] = "Soul Swap",
					["ID"] = 86121,
					["Data"] = { 0.174, 0, 0.2 },
					[0] = { School = { "Shadow", "Affliction" }, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(71521)] = {
					["Name"] = "Hand of Gul'Dan",
					["ID"] = 71521,
					["Data"] = { 1.593, 0.166, 0.968 },
					[0] = { School = "Shadowflame", Double = { "Shadow", "Fire" }, Cooldown = 12, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(77799)] = {
					["Name"] = "Fel Flame",
					["ID"] = 77799,
					["Data"] = { 0.248, 0.15, 0.302 },
					[0] = { School = "Shadowflame", Double = { "Shadow", "Fire" }, },
					[1] = { 0, 0, },
		},
	}
	self.talentInfo = {
	--AFFLICTION
	--DEMONOLOGY
	--DESTRUCTION:
	}
end
